Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.dom4j
Interface XPath

All Superinterfaces:
  NodeFilter

All Known Implementing Classes:
  DefaultXPath

public interface XPath
extends NodeFilter

`XPath` represents an XPath expression after it has been parsed from a String.

Version:
  $Revision: 1.20 $
Author:
  James Strachan

Method Summary
`boolean` | `booleanValueOf(Object context)` Retrieve a boolean-value interpretation of this XPath expression when evaluated against a given context.
`Object` | `evaluate(Object context)` `evaluate` evaluates an XPath expression and returns the result as an `Object`.
`org.jaxen.FunctionContext` | `getFunctionContext()` DOCUMENT ME!
`org.jaxen.NamespaceContext` | `getNamespaceContext()` DOCUMENT ME!
`String` | `getText()` `getText` will return the textual version of the XPath expression.
`org.jaxen.VariableContext` | `getVariableContext()` DOCUMENT ME!
`boolean` | `matches(Node node)` `matches` returns true if the given node matches the XPath expression.
`Number` | `numberValueOf(Object context)` `numberValueOf` evaluates an XPath expression and returns the numeric value of the XPath expression if the XPath expression results is a number, or null if the result is not a number.
`List` | `selectNodes(Object context)` `selectNodes` performs this XPath expression on the given `Node`or `List`of `Node`s instances appending all the results together into a single list.
`List` | `selectNodes(Object context, XPath sortXPath)` `selectNodes` evaluates the XPath expression on the given `Node`or `List`of `Node`s and returns the result as a `List` of `Node` s sorted by the sort XPath expression.
`List` | `selectNodes(Object context, XPath sortXPath, boolean distinct)` `selectNodes` evaluates the XPath expression on the given `Node`or `List`of `Node`s and returns the result as a `List` of `Node` s sorted by the sort XPath expression.
`Object` | `selectObject(Object context)` Deprecated. please use evaluate(Object) instead. WILL BE REMOVED IN dom4j-1.6 !!
`Node` | `selectSingleNode(Object context)` `selectSingleNode` evaluates this XPath expression on the given `Node`or `List`of `Node`s and returns the result as a single `Node` instance.
`void` | `setFunctionContext(org.jaxen.FunctionContext functionContext)` Sets the function context to be used when evaluating XPath expressions
`void` | `setNamespaceContext(org.jaxen.NamespaceContext namespaceContext)` Sets the namespace context to be used when evaluating XPath expressions
`void` | `setNamespaceURIs(Map map)` Sets the current NamespaceContext from a Map where the keys are the String namespace prefixes and the values are the namespace URIs.
`void` | `setVariableContext(org.jaxen.VariableContext variableContext)` Sets the variable context to be used when evaluating XPath expressions
`void` | `sort(List list)` `sort` sorts the given List of Nodes using this XPath expression as a `Comparator`.
`void` | `sort(List list, boolean distinct)` `sort` sorts the given List of Nodes using this XPath expression as a `Comparator`and optionally removing duplicates.
`String` | `valueOf(Object context)` `valueOf` evaluates this XPath expression and returns the textual representation of the results using the XPath string() function.

Method Detail

### getText

    public String getText()

  `getText` will return the textual version of the XPath expression.

  Returns:
    the textual format of the XPath expression.

### matches

    public boolean matches(Node node)

  `matches` returns true if the given node matches the XPath expression. To be more precise when evaluating this XPath expression on the given node the result set must include the node.

  Specified by:
    `matches` in interface `NodeFilter`
  Parameters:
    `node` - DOCUMENT ME!
  Returns:
    true if the given node matches this XPath expression

### evaluate

    public Object evaluate(Object context)

  `evaluate` evaluates an XPath expression and returns the result as an `Object`. The object returned can either be a `List` of `Node`instances, a `Node`instance, a `String` or a `Number`instance depending on the XPath expression.

  Parameters:
    `context` - is either a node or a list of nodes on which to evalute the XPath
  Returns:
    the value of the XPath expression as a `List`of `Node` instances, a `Node`instance, a `String`or a `Number`instance depending on the XPath expression.

### selectObject

    public Object selectObject(Object context)

  Deprecated. please use evaluate(Object) instead. WILL BE REMOVED IN dom4j-1.6 !!

  `selectObject` evaluates an XPath expression and returns the result as an `Object`. The object returned can either be a `List` of `Node`instances, a `Node`instance, a `String` or a `Number`instance depending on the XPath expression.

  Parameters:
    `context` - is either a node or a list of nodes on which to evalute the XPath
  Returns:
    the value of the XPath expression as a `List`of `Node` instances, a `Node`instance, a `String`or a `Number`instance depending on the XPath expression.

### selectNodes

    public List selectNodes(Object context)

  `selectNodes` performs this XPath expression on the given `Node`or `List`of `Node`s instances appending all the results together into a single list.

  Parameters:
    `context` - is either a node or a list of nodes on which to evalute the XPath
  Returns:
    the results of all the XPath evaluations as a single list

### selectNodes

    public List selectNodes(Object context,
                            XPath sortXPath)

  `selectNodes` evaluates the XPath expression on the given `Node`or `List`of `Node`s and returns the result as a `List` of `Node` s sorted by the sort XPath expression.

  Parameters:
    `context` - is either a node or a list of nodes on which to evalute the XPath
    `sortXPath` - is the XPath expression to sort by
  Returns:
    a list of `Node` instances

### selectNodes

    public List selectNodes(Object context,
                            XPath sortXPath,
                            boolean distinct)

  `selectNodes` evaluates the XPath expression on the given `Node`or `List`of `Node`s and returns the result as a `List` of `Node` s sorted by the sort XPath expression.

  Parameters:
    `context` - is either a node or a list of nodes on which to evalute the XPath
    `sortXPath` - is the XPath expression to sort by
    `distinct` - specifies whether or not duplicate values of the sort expression are allowed. If this parameter is true then only distinct sort expressions values are included in the result
  Returns:
    a list of `Node` instances

### selectSingleNode

    public Node selectSingleNode(Object context)

  `selectSingleNode` evaluates this XPath expression on the given `Node`or `List`of `Node`s and returns the result as a single `Node` instance.

  Parameters:
    `context` - is either a node or a list of nodes on which to evalute the XPath
  Returns:
    a single matching `Node` instance

### valueOf

    public String valueOf(Object context)

  `valueOf` evaluates this XPath expression and returns the textual representation of the results using the XPath string() function.

  Parameters:
    `context` - is either a node or a list of nodes on which to evalute the XPath
  Returns:
    the string representation of the results of the XPath expression

### numberValueOf

    public Number numberValueOf(Object context)

  `numberValueOf` evaluates an XPath expression and returns the numeric value of the XPath expression if the XPath expression results is a number, or null if the result is not a number.

  Parameters:
    `context` - is either a node or a list of nodes on which to evalute the XPath
  Returns:
    the numeric result of the XPath expression or null if the result is not a number.

### booleanValueOf

    public boolean booleanValueOf(Object context)

  Retrieve a boolean-value interpretation of this XPath expression when evaluated against a given context.

  The boolean-value of the expression is determined per the `boolean(..)` core function as defined in the XPath specification. This means that an expression that selects zero nodes will return `false`, while an expression that selects one-or-more nodes will return `true`.

  Parameters:
    `context` - The node, nodeset or Context object for evaluation. This value can be null
  Returns:
    The boolean-value interpretation of this expression.
  Since:
    1.5

### sort

    public void sort(List list)

  `sort` sorts the given List of Nodes using this XPath expression as a `Comparator`.

  Parameters:
    `list` - is the list of Nodes to sort

### sort

    public void sort(List list,
                     boolean distinct)

  `sort` sorts the given List of Nodes using this XPath expression as a `Comparator`and optionally removing duplicates.

  Parameters:
    `list` - is the list of Nodes to sort
    `distinct` - if true then duplicate values (using the sortXPath for comparisions) will be removed from the List

### getFunctionContext

    public org.jaxen.FunctionContext getFunctionContext()

  DOCUMENT ME!

  Returns:
    the current function context

### setFunctionContext

    public void setFunctionContext(org.jaxen.FunctionContext functionContext)

  Sets the function context to be used when evaluating XPath expressions

  Parameters:
    `functionContext` - DOCUMENT ME!

### getNamespaceContext

    public org.jaxen.NamespaceContext getNamespaceContext()

  DOCUMENT ME!

  Returns:
    the current namespace context

### setNamespaceContext

    public void setNamespaceContext(org.jaxen.NamespaceContext namespaceContext)

  Sets the namespace context to be used when evaluating XPath expressions

  Parameters:
    `namespaceContext` - DOCUMENT ME!

### setNamespaceURIs

    public void setNamespaceURIs(Map map)

  Sets the current NamespaceContext from a Map where the keys are the String namespace prefixes and the values are the namespace URIs.

  For example:

       Map uris = new HashMap();
       uris.put("SOAP-ENV", "http://schemas.xmlsoap.org/soap/envelope/");
       uris.put("m", "urn:xmethodsBabelFish");
       XPath xpath = document
               .createXPath("SOAP-ENV:Envelope/SOAP-ENV:Body/m:BabelFish");
       xpath.setNamespaceURIs(uris);
       Node babelfish = xpath.selectSingleNode(document);

  Parameters:
    `map` - the map containing the namespace mappings

### getVariableContext

    public org.jaxen.VariableContext getVariableContext()

  DOCUMENT ME!

  Returns:
    the current variable context

### setVariableContext

    public void setVariableContext(org.jaxen.VariableContext variableContext)

  Sets the variable context to be used when evaluating XPath expressions

  Parameters:
    `variableContext` - DOCUMENT ME!

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2005 MetaStuff Ltd.. All Rights Reserved.